#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <X11/X.h>
#include <X11/xpm.h>
#include "wmwifi.h"
#include <net/ethernet.h>
#include <linux/if.h>
#include <linux/socket.h>
#include <linux/wireless.h>

/*
 * This is my quick and dirty way of accessing the Linux Wireless Extensions
 * from the /proc/net/wireless interface.
 * Open the file, and get the Interface name, link, level, and noise. 
 * - Jess
 */

int get_max_qual(char ifname[255])
{
    struct iwreq wrq;
    struct iw_range range;
    int skfd;
    float ret;


    skfd = socket(AF_INET, SOCK_DGRAM, 0);

    memset(&range, 0, sizeof(struct iw_range));

    wrq.u.data.pointer = (caddr_t) & range;
    wrq.u.data.length = sizeof(struct iw_range);
    wrq.u.data.flags = 0;
    strncpy(wrq.ifr_name, ifname, IFNAMSIZ);
    ret = ioctl(skfd, SIOCGIWRANGE, &wrq);

    if (ret > -1) {
	ret = range.max_qual.qual;
    }

    close(skfd);

    return ret;
}
void next_if(struct wifi *wfi)
{
    int max;

    max = get_max_ifs();

    if (wfi->ifnum < max) {
	wfi->ifnum++;
    } else {
	wfi->ifnum = 0;
    }
}
void last_if(struct wifi *wfi)
{
    int max;

    max = get_max_ifs();

    if (wfi->ifnum > 0) {
	wfi->ifnum--;
    } else {
	wfi->ifnum = max;
    }
}
int get_max_ifs(void)
{
    FILE *fp;
    char buff[255];
    int i = 0;

    if (fp = fopen("/proc/net/wireless", "r")) {
	for (i = -3; fgets(buff, sizeof(buff), fp); i++) {
	}
	fclose(fp);
    }
    return i;
}
int wifi_info(struct wifi *wfi)
{
    FILE *fp;
    char buff[255], level[255];
    int i;
    int max;

    max = get_max_ifs();

    if (fp = fopen("/proc/net/wireless", "r")) {
	for (i = 0; i < (wfi->ifnum + 3); i++) {
	    fgets(buff, sizeof(buff), fp);
	}
	sscanf(buff, "%s %*s %s %*s %*s", wfi->ifname, level);

	wfi->link = atoi(level);
	wfi->max_qual = get_max_qual(wfi->ifname);

	fclose(fp);
    } else {
	fprintf(stdout,
		"ERROR: Cannot Open Linux Wireless Extensions!\n\b");
	exit(1);
    }
    return 1;
}
